// version 120ł͕Kv
#version 120 
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

// CIRL GPU Geometry Program: Derek Anderson and Robert Luke
// very simple geometry shader

/*
GEOMETRY SHADER DOCUMENTATION

Geometry language built-in outputs:
	varying out vec4 gl_FrontColor;
	varying out vec4 gl_BackColor;
	varying out vec4 gl_FrontSecondaryColor;
	varying out vec4 gl_BackSecondaryColor;
	varying out vec4 gl_TexCoord[]; 	// at most gl_MaxTextureCoords
	varying out float gl_FogFragCoord; 

Geometry language input varying variables:
	varying in vec4 gl_FrontColorIn[gl_VerticesIn];
	varying in vec4 gl_BackColorIn[gl_VerticesIn];
	varying in vec4 gl_FrontSecondaryColorIn[gl_VerticesIn];
	varying in vec4 gl_BackSecondaryColorIn[gl_VerticesIn];
	varying in vec4 gl_TexCoordIn[gl_VerticesIn][]; 	// at most will be// gl_MaxTextureCoords
	varying in float gl_FogFragCoordIn[gl_VerticesIn];
	varying in vec4 gl_PositionIn[gl_VerticesIn];
	varying in float gl_PointSizeIn[gl_VerticesIn];
	varying in vec4 gl_ClipVertexIn[gl_VerticesIn];

Geometry Shader Function 
	
	WIgVF[_ł2̊֐Ă
	
	Syntax:
	 void EmitVertex(); 
	 void EndPrimitive(); 
	
	Description:
	
	 EmitVertex()Œ_̐ݒ
	 i1̒_ݒĂяoKvLj
 
	 EndPrimitive()Ńv~eBu̐ݒ̃v~eBuJn
	 iGL_POINTSȂ1̒_EmitVertex()ɌĂяoA
	 @GL_TRIANGLESȂ3̒_EmitVertex()ɌĂяoj
*/

// ̈ʒu͌Œ
const vec3 lightPos = vec3(0, 3.0, 5.0);

// @itriangleȂ̂Ŏ󂯎Ƃ3̔zj
varying in vec3 normal[3];
varying out float LightIntensity;

vec3 V[3];
vec4 color[8];

void ProduceVertex(int v, vec4 color)
{
    // ȈՃVF[fBO
    LightIntensity = dot( normalize(lightPos-V[v]), normal[v] );
    LightIntensity = abs(LightIntensity);
    LightIntensity *= 1.5;

    // _̐F
    gl_FrontColor = color;

    // _̏o
	gl_Position = gl_ModelViewProjectionMatrix * vec4(V[v], 1);
    EmitVertex();
}

void main(void)
{
    // _̐Fݒ
    color[0] = vec4(1.0, 0.0, 0.0, 1.0);
    color[1] = vec4(0.0, 1.0, 0.0, 1.0);
    color[2] = vec4(0.0, 0.0, 1.0, 1.0);
    color[3] = vec4(0.0, 1.0, 1.0, 1.0);
    color[4] = vec4(1.0, 0.0, 1.0, 1.0);
    color[5] = vec4(1.0, 1.0, 0.0, 1.0);
    color[6] = vec4(1.0, 1.0, 1.0, 1.0);
    color[7] = vec4(0.0, 0.0, 0.0, 1.0);

	// ̃f[^擾
	for (int i=0; i<gl_VerticesIn; i++)
	{
        V[i] = gl_PositionIn[i].xyz;
	}

	// ̃f[^`
	// eB[|bg͖ʂvĤߋt
	ProduceVertex(0, color[1]);
	ProduceVertex(2, color[1]);
	ProduceVertex(1, color[1]);
	EndPrimitive();

	// ֊s`
	// @ɒ_ړ
	for (int i=0; i<gl_VerticesIn; i++)
	{
		// ړʂŗ֊s̑𒲐߉\
		V[i] += 0.1*normal[i];
	}

	// ʂ̏o(ʂɂ邽ߏԂύX)
	ProduceVertex(0, color[7]);
	ProduceVertex(1, color[7]);
	ProduceVertex(2, color[7]);
	EndPrimitive();
}
